/* *********************************************************** */
/* test4.c                                                     */
/* exersice 4   -  Using functions                          	*/
/*         */
/* *********************************************************** */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <search.h>

#define TERMINATE			0
#define GET_WORDS			1
#define INCR_SORT			2
#define DECR_SORT			3
#define DISPLAY_WORDS	4
#define STATISTICS		5

#define MAX_WORDS	5
#define MAX_WORD_LEN	40

char word[MAX_WORDS][MAX_WORD_LEN];

int menu(void);
void get_words(void);
void incremental_sort(void);
void decremental_sort(void);
void display_words(void);
void do_statistics(void);

int compare4inc(const void *elem1, const void *elem2);
int compare4dec(const void *elem1, const void *elem2);


void main()
{
int selected_op;

while((selected_op=menu())!= TERMINATE){
	switch(selected_op){
   	case GET_WORDS :
      	get_words();
      	break;
		case INCR_SORT :
      	incremental_sort();
      	break;
      case DECR_SORT  :
      	decremental_sort();
      	break;
      case DISPLAY_WORDS :
			display_words();
      	break;
      case STATISTICS :
			do_statistics();
      	break;
      default :
      	printf(" o  \n");
      	break;
   	}
	}
}

int menu(void)
{
int choice;

printf("\n\n\n\n\n");
printf("0 - TERMINATE\n");
printf("1 - GET WORDS\n");
printf("2 - INCREMENTAL SORT\n");
printf("3 - DECREMENTAL SORT\n");
printf("4 - DISPLAY WORDS\n");
printf("5 - DO STATISTICS\n\n");
printf("Select operation:");
scanf("%d",&choice);
return (choice);
}

void get_words(void)
{
int i;

printf(" %d \n",MAX_WORDS);
for(i=0;i<MAX_WORDS;i++)
	scanf("%s",word[i]);
}


void incremental_sort(void)
{
qsort((void *)word, MAX_WORDS,MAX_WORD_LEN, compare4inc );
printf("incremental_sort ok\n");
}

int compare4inc(const void *elem1, const void *elem2)
{
return(strcmp(elem1,elem2));
}

void decremental_sort(void)
{
qsort((void *)word, MAX_WORDS,MAX_WORD_LEN, compare4dec );
printf("decremental_sort ok\n");
}

int compare4dec(const void *elem1, const void *elem2)
{
return(-strcmp(elem1,elem2));
}

void display_words(void)
{
int i;
printf("display_words\n");
for(i=0;i<MAX_WORDS;i++)
	printf("%s\n",word[i]);
}

/*  ,        */
void do_statistics(void)
{
int word_len[MAX_WORDS];
int max_len, min_len,i;
int total_len=0;

for(i=0;i<MAX_WORDS;i++)
	word_len[i]=strlen(word[i]);

max_len = min_len = word_len[0];
for(i=0;i<MAX_WORDS;i++){
	max_len = max_len>word_len[i]?max_len:word_len[i];
   min_len = min_len<word_len[i]?min_len:word_len[i];
   total_len += word_len[i];
	}
printf("max len = %d\n",max_len);
printf("min len = %d\n",min_len);
printf("average len = %d\n",total_len/MAX_WORDS);
}
