/* *********************************************************** */
/* test4.c                                                     */
/* exersice 4 - step 6 					                         	*/
/*         */
/* *********************************************************** */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <search.h>

#define TERMINATE			0
#define GET_WORDS			1
#define INCR_SORT			2
#define DECR_SORT			3
#define DISPLAY_WORDS	4
#define STATISTICS		5
#define CHAR_STATISTICS	6


#define MAX_WORDS	5
#define MAX_WORD_LEN	40

char word[MAX_WORDS][MAX_WORD_LEN];

int menu(void);
void get_words(void);
void incremental_sort(void);
void decremental_sort(void);
void display_words(void);
void do_char_statistics(char ch);
void do_statistics(void);

int compare4inc(const void *elem1, const void *elem2);
int compare4dec(const void *elem1, const void *elem2);

int count_ch(char ch, char word[]);


/* ***************** */
void main()
/* ***************** */
{
int selected_op;
char ch;

while((selected_op=menu())!= TERMINATE){
	switch(selected_op){
   	case GET_WORDS :
      	get_words();
      	break;
		case INCR_SORT :
      	incremental_sort();
      	break;
      case DECR_SORT  :
      	decremental_sort();
      	break;
      case DISPLAY_WORDS :
			display_words();
      	break;
      case CHAR_STATISTICS :
         printf(" \n");
			fflush(stdin);
         scanf("%c",&ch);
			do_char_statistics(ch);
      	break;
      case STATISTICS :
			do_statistics();
      	break;
      default :
      	printf(" o  \n");
      	break;
   	}
	}
}

/* ***************** */
int menu(void)
/* ***************** */
{
int choice;

printf("\n\n\n\n");
printf("0 - TERMINATE\n");
printf("1 - GET WORDS\n");
printf("2 - INCREMENTAL SORT\n");
printf("3 - DECREMENTAL SORT\n");
printf("4 - DISPLAY WORDS\n");
printf("5 - DO STATISTICS\n");
printf("6 - DO CHARACTER STATISTICS\n");
printf("Select operation:");

scanf("%d",&choice);
printf("\n");
return (choice);
}


/* ***************** */
void get_words(void)
/* ***************** */
{
int i;

printf("\n %d \n",MAX_WORDS);
for(i=0;i<MAX_WORDS;i++)
	scanf("%s",word[i]);
}


/* ***************** */
void incremental_sort(void)
/* ***************** */
{
qsort((void *)word, MAX_WORDS,MAX_WORD_LEN, compare4inc );
printf("incremental_sort ok\n");
}

/* ***************** */
int compare4inc(const void *elem1, const void *elem2)
/* ***************** */
{
return(strcmp(elem1,elem2));
}

/* ***************** */
void decremental_sort(void)
/* ***************** */
{
qsort((void *)word, MAX_WORDS,MAX_WORD_LEN, compare4dec );
printf("decremental_sort ok\n");
}

/* ***************** */
int compare4dec(const void *elem1, const void *elem2)
/* ***************** */
{
return(-strcmp(elem1,elem2));
}

/* ***************** */
void display_words(void)
/* ***************** */
{
int i;
printf("display_words\n");
for(i=0;i<MAX_WORDS;i++)
	printf("%s\n",word[i]);
}

/* ***************** */
/*  ,        */
void do_statistics(void)
/* ***************** */
{
int word_len[MAX_WORDS];
int max_len, min_len,i;
int total_len=0;

for(i=0;i<MAX_WORDS;i++)
	word_len[i]=strlen(word[i]);

max_len = min_len = word_len[0];
for(i=0;i<MAX_WORDS;i++){
	max_len = max_len>word_len[i]?max_len:word_len[i];
   min_len = min_len<word_len[i]?min_len:word_len[i];
   total_len += word_len[i];
	}
printf("max len = %d\n",max_len);
printf("min len = %d\n",min_len);
printf("average len = %d\n",total_len/MAX_WORDS);
}

/* ***************** */
/*  ,       */
/*       */
void do_char_statistics(char ch)
/* ***************** */
{
int char_ap[MAX_WORDS];
int max_ap, min_ap,total_ap;
int i;

for(i=0;i<MAX_WORDS;i++)
	char_ap[i]= count_ch(ch,word[i]);

/*   */
for(i=0;i<MAX_WORDS;i++)
	printf("debug info> %s --> %d\n",word[i],char_ap[i]);

max_ap = min_ap = char_ap[0];
total_ap = 0;
for(i=0;i<MAX_WORDS;i++){
	max_ap = max_ap>char_ap[i]?max_ap:char_ap[i];
   min_ap = min_ap<char_ap[i]?min_ap:char_ap[i];
   total_ap += char_ap[i];
	}

printf("max ap = %d\n",max_ap);
printf("min ap = %d\n",min_ap,word[i]);
printf("total ap = %d\n",total_ap);
printf("average ap = %f\n",(float)total_ap/MAX_WORDS);
}


/* ***************** */
int count_ch(char ch, char word[])
/* ***************** */
{
int i=0;
int count = 0;

while(word[i]!= '\0')
	word[i++]== ch? count++ : count;
return count;
}
