#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
//#include <fcntl.h>
//#include <sys/types.h>
//#include <sys/stat.h>
//#include <unistd.h>

#define TERMINATE    0
#define INSERT_ITEM  1
#define DISPLAY      2
#define LOOK4ITEM    3
#define DELETE_ITEM  4
#define SAVE_LIST    5
#define LOAD_LIST    6
#define NAME_LEN    50
#define PHONE_LEN   50
#define EMAIL_LEN   50


struct item {
	char name[NAME_LEN];
	char phone[PHONE_LEN];
	char email[EMAIL_LEN];
	struct item *next;
};
typedef struct item ITEM;
typedef ITEM *PITEM;



int menu(void);
void insert_item(PITEM *,PITEM);
void display(PITEM);
void look4item(PITEM,char *);
void delete_item(PITEM *,char *);
void save_list(PITEM);
void load_list(void);
void get_item(void);
void display_item(PITEM);
PITEM head=NULL;
PITEM *head_ptr=&head;

void main()
{
        int select_op;
	char* data;
	char* del;

	while ((select_op = menu())!=TERMINATE){
		switch(select_op){
		case INSERT_ITEM:
			get_item();
			break;
		case DISPLAY:
			display(head);
			break;
		case LOOK4ITEM:
			data=(char *)malloc(50*(sizeof(char)));
			printf("Dwste to onoma:\n");
			scanf("%s",data);
                        look4item(head,data);
			free(data);
			break;
		case DELETE_ITEM:
			del=(char *)malloc(50*(sizeof(char)));
			printf("Dwste to onoma:\n");
			scanf("%s",del);
			delete_item(&head,del);
			free(del);
			break;
		case SAVE_LIST:
			save_list(head);
			break;
		case LOAD_LIST:
			load_list();
			break;
		default:
			printf("H leitourgia den ypostirizetai\n");
			break;
		}
	}
}

int menu(void)
{
	int choice;
	printf("\n\n\n\n\n");
	printf("0-TERMINATE\n");
	printf("1-INSERT ITEM\n");
	printf("2-DISPLAY CATALOG\n");
	printf("3-LOOK FOR ITEM\n");
	printf("4-DELETE ITEM\n");
	printf("5-SAVE LIST\n");
	printf("6-LOAD LIST\n");
	printf("Select operation:");
	scanf("%d",&choice);
	if(choice==TERMINATE){
		printf("End of process!\n");
		return 0;
	}
	return choice;
}


void insert_item(PITEM *head_ptr,PITEM p)
{
	PITEM p_cur;

	if(*head_ptr==NULL){
		*head_ptr=p;
		p->next=NULL;
		return;
	}
	if(strcmp(p->name,(*head_ptr)->name)<0){
		p->next=*head_ptr;
		*head_ptr=p;
		return;
	}
	p_cur=*head_ptr;
	while((p_cur->next!=NULL)&&strcmp(p_cur->next->name,p->name)<0)
		p_cur=p_cur->next;
	p->next=p_cur->next;
	p_cur->next=p;
}

void look4item(PITEM head,char *name)
{
	PITEM p_cur;
	putchar('\n');
	if(head==NULL){
		printf("No items in list\n");
		return;
	}
	p_cur=head;
	while(strcmp(p_cur->name,name)&&p_cur->next!=NULL)
		p_cur=p_cur->next;

        if((strcmp(p_cur->name,name))==0){
		printf("The item is found\n");
		display_item(p_cur);
	}
	else
		printf("Name is not in list\n");
}

void save_list(PITEM head)
{
	FILE *fd;
	PITEM p_cur;

	if((fd=fopen("catalog.txt","w"))==NULL)
	printf("Problem at creating file 'catalog'");
	else{
		p_cur=head;
		do{
			write(fd,(char *)p_cur,sizeof(ITEM));
			p_cur=p_cur->next;
		}while(p_cur!=NULL);
		fclose(fd);
	}
}

void display_item(PITEM p)
{
	printf("NAME:%s\n",p->name);
	printf("PHONE:%s\n",p->phone);
	printf("EMAIL:%s\n",p->email);
}

void delete_item(PITEM *head_ptr,char *ptr)
{
	PITEM p_cur,p_prev;

	if(*head_ptr==NULL)
		printf("Nothing in the list\n");

	p_cur=*head_ptr;
	if(strcmp(ptr,p_cur->name)==0){
		if((p_cur->next)!=NULL){
		*head_ptr=p_cur->next;
		return;
		}
		else{
		*head_ptr=NULL;
		return;
                }
		}


	while(strcmp(ptr,p_cur->name)!=0&&(p_cur->next)!=NULL){
		p_prev=p_cur;
		p_cur=p_cur->next;
	}
		if(strcmp(ptr,p_cur->name)==0){
			if((p_cur->next)!=NULL)
			p_prev->next=p_cur->next;
			else
			if(p_cur->next==NULL)
				p_prev->next=NULL;
		}
		else
		printf("To stoixeio den yparxei\n");
}

void display(PITEM head)
{
	PITEM p_cur;
	p_cur=head;

	while(p_cur!=NULL){
		printf("%s\n",p_cur->name);
		p_cur=p_cur->next;
	}
}

void load_list(void)
{
	FILE *fd;
	int n;
	PITEM handle;
	int notEOF=1;

	if((fd=fopen("catalog.txt","r"))<0)
		printf("Problem at opening file 'catalog'");
	else{
		while(1){
			handle=(PITEM)malloc(sizeof(ITEM));
			printf("after malloc\n");
			n=read(fd,(PITEM)handle,sizeof(ITEM));
			if (n<=0)
				break;
			printf("after read\n");
			insert_item(&head,handle);
			printf("after insert\n");
			}
	printf("List loaded\n");
	}
   fclose(fd);
}

void get_item(void)
{
	PITEM p;

	p=(PITEM)malloc(sizeof(ITEM));
   printf("Dose onoma:");
	scanf("%s",p->name);
   printf("Dose tel:");
	scanf("%s",p->phone);
   printf("Dose e-mail:");
	scanf("%s",p->email);

	insert_item(&head,p);
}












