#include <stdio.h>
#include <stdlib.h>
#include <string.h> 

#define NAME_LEN 15 
#define PHONE_LEN 20
#define EMAIL_LEN 35
#define FILE_LEN 13

struct item {
	char name[NAME_LEN];
	char phone[PHONE_LEN];
	char email[EMAIL_LEN];
	struct item *next;
};

typedef struct item ITEM;
typedef ITEM *PITEM; 

PITEM head = NULL ;

PITEM read_item(void);
void insert_item(PITEM *, PITEM);
PITEM look4item(PITEM);
void display_item(PITEM);
void view_book(PITEM);
void delete_item(PITEM *, PITEM);
void save_list(PITEM);
void load_list(PITEM *);

main()
{
char menu=1;
int i;

/* Menu */

while (menu != '0'){

		printf("\n1. Add to list\n"
			"2. View list\n"
			"3. Find entry by name\n"
			"4. Delete entry\n"
			"5. Load list\n"
			"6. Save list\n"
			"0. Exit program\n\n"
			"Enter your choice: ");
	
		menu=getchar();
		fflush(stdin);

		switch (menu){
	
		case '1':
			insert_item(&head, read_item());
			break;
		case '2':
			view_book(head);
			break;
		case '3':
			display_item(look4item(head));
			break;
		case '4':
			delete_item(&head,look4item(head));
			break;
		case '5':
			load_list(&head);
			break;
		case '6':
			save_list(head);
			break;
		case '0':
			for (i=0;i<24;i++) {printf("\n");}
			printf("Bye!!!\n");
			break;
		default:
			printf("\n\aUnknown choice!!\nPlease try again:\n");
			break;
		}
	}

return(0);
}

PITEM read_item(void) {
	
	PITEM start; 
	
	start = (PITEM)malloc(sizeof(ITEM)); 
	
	if (start==NULL){
		printf("\aError allocating memory!");
		return start;}
	
	printf("\nName ? ");
	fgets(start->name,NAME_LEN-2,stdin);
	printf("\nPhone number ? ");
	fgets(start->phone,PHONE_LEN-2,stdin);
	printf("\nEmail address ? ");
	fgets(start->email,EMAIL_LEN-2,stdin);
	
	return start;
}

void insert_item(PITEM *head_ptr, PITEM p)
{
	PITEM p_cur;

	/* An einai to prwto stoixeio */

	if (*head_ptr==NULL) { 
		*head_ptr=p;
		p->next=NULL;
		return;
	}

	/* An prepei na bei prwto */

	if(strcmp(p->name,(*head_ptr)->name)<0) {
		p->next = *head_ptr;
		*head_ptr = p;
		return;
	}

	/* Se ka8e allh periptwsh */
	p_cur=*head_ptr;
	while((p_cur->next != NULL) && strcmp(p_cur->next->name,p->name)<0)
		p_cur = p_cur->next;
	p->next=p_cur->next;
	p_cur->next=p;
}

void view_book(PITEM head){
	
	PITEM p_cur;
	int printed_itms=1;
	
	if (head==NULL){
		printf("\nNo items in list!\n");
		return;
	}
		
	p_cur=head;
	
	do {
		display_item(p_cur);
		p_cur = p_cur->next;
		if (printed_itms==3){  /*Pause ka8e 3 emfaniseis */
			printf("Press enter to continue...");
			getchar();
			printed_itms=1;
		}
		else 
			printed_itms++;
	}while(p_cur!=NULL);
	
	return;
}

PITEM look4item(PITEM head) {

	char name[NAME_LEN];
	PITEM p_cur;
	
	if (head==NULL) {
		printf("\nNo items in list!\n");
		return head;
		}
	
	printf("\nName you are looking for? ");
	fgets(name,NAME_LEN-2,stdin);

	p_cur = head;

	while(strcmp(p_cur->name,name) && p_cur->next!=NULL)
		p_cur = p_cur->next;

	/*Ean den bre8ei, epestrepse null*/
	if(strcmp(p_cur->name,name) != 0){
		printf("\nNo such name in list (case sesitive?)\n");
		p_cur=NULL;
	}

	return p_cur;
}


void display_item(PITEM pnt){
	
	if (pnt==NULL) 
		return;

	printf("----------------------------------------\n"
		"Name:  %s"
		"Phone: %s"
		"Email: %s"
		"----------------------------------------"
		"\n",pnt->name,pnt->phone,pnt->email);
	return;
}


void delete_item(PITEM *head_ptr, PITEM p){
	
	PITEM p_cur;
	char confirm;
	
	if (p == NULL) return; /* den exei epistrafei item */
	
	display_item(p);/*Epibebaiwsh diagrafhs*/
	printf("\nPress y to delete the above item... ");
	confirm=getchar();
	fflush(stdin);
	
	if (confirm == 'y' || confirm == 'Y'){}
	else {
		printf("\nAbording deletion!\n");
		return;
	}
	
	if (*head_ptr==p){ /* sbhnei to prwto stoixeio */
		*head_ptr=p->next;
		free(p);
		return;
	}

	/* Opoiadhpote allh periptwsh */
	p_cur=*head_ptr;
	while(p_cur->next!=p){
		p_cur=p_cur->next;
	}
	p_cur->next=p->next;
	free(p);
	return;
}

void save_list(PITEM head){

	FILE *ofp;
	char fname[FILE_LEN];
	PITEM p_cur=head;
	
	if (head==NULL){
		printf("\nNo items to save!\n");
		return;
	}

	printf("\nSaving file...");
	printf("\nEnter file name, max %d chars: ",FILE_LEN-5);
	scanf("%s", fname);
	fflush(stdin);

	strncat(fname,".lst",4); /* Pros8esh extension .lst */
	ofp = fopen(fname, "w");
	
	if (ofp==NULL) {/* Epistrofh NULL se "w" -> write error */
		printf("\a\nError opening file - saving aborted!\n");
		return;
	}

	do{
		fprintf(ofp,"%s%s%s",p_cur->name,p_cur->phone,p_cur->email);
		p_cur=p_cur->next;
	}while(p_cur!=NULL);

	fclose(ofp);
	return;
}

void load_list(PITEM *head_ptr){

	FILE *ifp;
	char fname[FILE_LEN];
	PITEM p_cur;

	printf("\nLoading file...");
	printf("\nEnter file name, max %d chars: ",FILE_LEN-5);
	scanf("%s", fname);
	fflush(stdin);

	strncat(fname,".lst",4);
	ifp = fopen(fname, "r");
	
	if (ifp==NULL) { /* Epistrofh NULL se "r" -> no file */
		printf("\nFile does not exist!\n");
		return;
	}
	
	p_cur=(PITEM)malloc(sizeof(ITEM));
	
	/* fgets epistrefei NULL se EOF */
	while(fgets(p_cur->name,NAME_LEN-2,ifp)!=NULL){
		fgets(p_cur->phone,PHONE_LEN-2,ifp);
		fgets(p_cur->email,EMAIL_LEN-2,ifp);
		insert_item(head_ptr,p_cur);
		p_cur=(PITEM)malloc(sizeof(ITEM));
	}

	free(p_cur); /* H teleytaia malloc -> garbage */
	fclose(ifp);
	return;
}

