#include <stdio.h>
#include <malloc.h>
#include <string.h>

#define TERMINATE				0
#define INSERT_ADDRESS		1
#define DELETE_ADDRESS		2
#define LOOK4ADDRESS			3
#define DISPLAY_ADDRESSES	4

#define NAME_LEN	 40
#define PHONE_LEN	  8
#define EMAIL_LEN  30

struct address {
   char name[NAME_LEN];
   char phone[PHONE_LEN];
   char email[EMAIL_LEN];
	struct address *next;
	};

typedef struct address ADDRESS;
typedef ADDRESS *PADDRESS;

int menu(void);
void insert_address(PADDRESS *,PADDRESS);
void delete_address(PADDRESS, char *);
void look4address(PADDRESS, char *);
void display_addresses(PADDRESS);

PADDRESS get_address(void);
void display_address(PADDRESS);

PADDRESS new_addr_ptr;
PADDRESS head_ptr=NULL;	/* pointer to start of list */

/* ******************* */
void main()
/* ******************* */
{
int selected_op;
char name[NAME_LEN];


while((selected_op=menu())!= TERMINATE){
	printf("\n");
	switch(selected_op){
   	case INSERT_ADDRESS :
      	if((new_addr_ptr=get_address())!= NULL)
	      	insert_address(&head_ptr,new_addr_ptr);
         else
         	printf("Out of memory...");
      	break;
		case DELETE_ADDRESS :
			printf("    :");
         scanf("%s",name);
      	delete_address(head_ptr,name);
      	break;
      case LOOK4ADDRESS  :
			printf("Insert name to look for\n");
			scanf("%s",name);
      	look4address(head_ptr,name);
      	break;
      case DISPLAY_ADDRESSES :
			display_addresses(head_ptr);
      	break;
       default :
      	printf(" o  \n");
      	break;
   	}
	}
}

/* ******************************* */
int menu(void)
/* ******************************* */
{
int choice;

printf("\n\n\n");
printf("0 - TERMINATE\n");
printf("1 - INSERT ADDRESS\n");
printf("2 - DELETE ADDRESS\n");
printf("3 - LOOK FOR ADDRESS\n");
printf("4 - DISPLAY ADDRESSES\n");
printf("Select operation:");
scanf("%d",&choice);
return (choice);
}

/* ******************************* */
PADDRESS get_address(void)
/* ******************************* */
{
PADDRESS p;

if((p=(PADDRESS)malloc(sizeof(ADDRESS)))!=NULL) {
   printf("\n\nInsert new item\n");
	printf("Name:");
	scanf("%s",p->name);
	printf("Phone:");
	scanf("%s",p->phone);
	printf("email:");
	scanf("%s",p->email);
   }
return p;
}

/* ******************************* */
void display_address(PADDRESS p)
/* ******************************* */
{
printf("Name: %s\n",p->name);
printf("Phone: %s\n",p->phone);
printf("email: %s\n",p->email);
}

/* ******************************* */
void insert_address(PADDRESS *head_ptr, PADDRESS p)
/* ******************************* */
{
PADDRESS p_cur;

if(*head_ptr == NULL) {				  /* list is empty */
	*head_ptr = p;                  /*      */
   return;
	}

/*       */
if(strcmp(p->name,(*head_ptr)->name)<0){
	p->next = *head_ptr;
   *head_ptr = p;
   return;
	}

/*         */
p_cur = *head_ptr;
while((p_cur->next!=NULL) && strcmp(p_cur->next->name,p->name)<0)
	p_cur = p_cur->next;

/*       p_cur*/
p->next = p_cur->next;
p_cur->next = p;

}


/* ******************************* */
void delete_address(PADDRESS head, char * name)
/* ******************************* */
{
printf("delete address\n");
}

/* ******************************* */
void look4address(PADDRESS head, char *name)
/* ******************************* */
{
PADDRESS p_cur;

putchar('\n');

if(head == NULL){
	printf("No items in list\n");
   return;
	}

p_cur = head;
while(strcmp(p_cur->name,name)&& p_cur->next != NULL)
	p_cur = p_cur->next;

if(p_cur->next != NULL){
	printf("-----------------------------\n");
	display_address(p_cur);
   }
else
	printf("Name is not in list\n");

}


/* ******************************* */
void display_addresses(PADDRESS head)
/* ******************************* */
{
PADDRESS p_cur;
int i=0;

printf("\n\n");

if(head == NULL){
	printf("No items in list\n");
   return;
	}

printf("Items in list\n");
p_cur = head;
do{
	printf("%d)-----------------------------\n",++i);
	display_address(p_cur);
   p_cur = p_cur->next;
	}while(p_cur != NULL);
printf("\nTotal of %d items\n",i);
}
