#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>

#define TERMINATE		 	0
#define INSERT_ITEM		1
#define DELETE_ITEM		2
#define LOOK4ITEM			3
#define DISPLAY_ITEMS	4
#define SAVE_LIST			5
#define LOAD_LIST			6

#define NAME_LEN	 40
#define PHONE_LEN	  8
#define EMAIL_LEN  30
#define FNAME_LEN	  10

struct item {
   char name[NAME_LEN];
   char phone[PHONE_LEN];
   char email[EMAIL_LEN];
	struct item *next;
	};

typedef struct item ITEM;
typedef ITEM *PITEM;

int menu(void);
void insert_item(PITEM *,PITEM);
void delete_item(PITEM, char *);
void look4item(PITEM, char *);
void display_items(PITEM);
void save_list(PITEM,char *);
void load_list(PITEM,char *);

PITEM get_item(void);
void display_item(PITEM);

PITEM new_addr_ptr;
PITEM head_ptr=NULL;	/* pointer to start of list */

/* ******************* */
void main()
/* ******************* */
{
int selected_op;
char name[NAME_LEN];
char fname[FNAME_LEN];


while((selected_op=menu())!= TERMINATE){
	printf("\n");
	switch(selected_op){
   	case INSERT_ITEM :
      	if((new_addr_ptr=get_item())!= NULL)
	      	insert_item(&head_ptr,new_addr_ptr);
         else
         	printf("Out of memory...");
      	break;
		case DELETE_ITEM :
			printf("    :");
         scanf("%s",name);
      	delete_item(head_ptr,name);
      	break;
      case LOOK4ITEM  :
			printf("Insert name to look for\n");
			scanf("%s",name);
      	look4item(head_ptr,name);
      	break;
      case DISPLAY_ITEMS :
			display_items(head_ptr);
         break;
      case SAVE_LIST :
			printf("     ( 8 ):");
         scanf("%s",fname);
			save_list(head_ptr,fname);
         break;
      case LOAD_LIST :
			printf("     :");
         scanf("%s",fname);
         load_list(head_ptr,fname);
         break;
       default :
      	printf(" o  \n");
      	break;
   	}
	}
}

/* ******************************* */
int menu(void)
/* ******************************* */
{
int choice;

printf("\n\n\n");
printf("0 - TERMINATE\n");
printf("1 - INSERT ITEM\n");
printf("2 - DELETE ITEM\n");
printf("3 - LOOK FOR ITEM\n");
printf("4 - DISPLAY ITEMS\n");
printf("5 - SAVE LIST\n");
printf("6 - LOAD LIST\n");
printf("Select operation:");
scanf("%d",&choice);
return (choice);
}

/* ******************************* */
PITEM get_item(void)
/* ******************************* */
{
PITEM p;

if((p=(PITEM)malloc(sizeof(ITEM)))!=NULL) {
   printf("\nInsert new item\n");
	printf("Name:");
	scanf("%s",p->name);
	printf("Phone:");
	scanf("%s",p->phone);
	printf("email:");
	scanf("%s",p->email);
   }
return p;
}

/* ******************************* */
void display_item(PITEM p)
/* ******************************* */
{
printf("Name: %s\n",p->name);
printf("Phone: %s\n",p->phone);
printf("email: %s\n",p->email);
}

/* ******************************* */
void insert_item(PITEM *head_ptr, PITEM p)
/* ******************************* */
{
PITEM p_cur;

if(*head_ptr == NULL) {				  /* list is empty */
	*head_ptr = p;                  /*      */
   return;
	}

/*       */
if(strcmp(p->name,(*head_ptr)->name)<0){
	p->next = *head_ptr;
   *head_ptr = p;
   return;
	}

/*         */
p_cur = *head_ptr;
while((p_cur->next!=NULL) && strcmp(p_cur->next->name,p->name)<0)
	p_cur = p_cur->next;

/*       p_cur*/
p->next = p_cur->next;
p_cur->next = p;

}


/* ******************************* */
void delete_item(PITEM head, char * name)
/* ******************************* */
{
printf("delete item\n");
}

/* ******************************* */
void look4item(PITEM head, char *name)
/* ******************************* */
{
PITEM p_cur;

putchar('\n');

if(head == NULL){
	printf("No items in list\n");
   return;
	}

p_cur = head;
while(strcmp(p_cur->name,name)&& p_cur->next != NULL)
	p_cur = p_cur->next;

if(p_cur->next != NULL){
	printf("-----------------------------\n");
	display_item(p_cur);
   }
else
	printf("Name is not in list\n");

}


/* ******************************* */
void display_items(PITEM head)
/* ******************************* */
{
PITEM p_cur;
int i=0;

printf("\n\n");

if(head == NULL){
	printf("No items in list\n");
   return;
	}

printf("Items in list\n");
p_cur = head;
do{
	printf("%d)-----------------------------\n",++i);
	display_item(p_cur);
   p_cur = p_cur->next;
	}while(p_cur != NULL);
printf("\nTotal of %d items\n",i);
}

/* ******************************* */
void save_list(PITEM head,char *fname)
/* ******************************* */
{
int fd;
PITEM p_cur;

if((fd=creat(fname,S_IREAD | S_IWRITE)) == -1)
	printf("      %s", fname);
else {
	p_cur = head;
   do{
		write(fd,(char*)p_cur,sizeof(ITEM));
	   p_cur = p_cur->next;
		}while(p_cur != NULL);
   close(fd);
	}
}

/* ******************************* */
void load_list(PITEM head,char *fname)
/* ******************************* */
{
int fd;
ITEM item;

if((fd=open(fname,O_RDONLY)) == -1)
	printf(" o     %s", fname);
else {
	read(fd,(char*)&item,sizeof(ITEM));
   display_item(&item);
	read(fd,(char*)&item,sizeof(ITEM));
   display_item(&item);
	printf("     \n");
   close(fd);
	}
}
