#include <stdio.h>

#define TRUE	1
#define FALSE	0


/*    */
#define ROW	6
#define COLUMN	7

/*   */
#define SPACE	32
#define SHADOW1	176
#define SHADOW2 177
#define LIGHT	219
#define STAR	'*'
#define CROSS	'+'

#define NONE	0
#define PLAYER1	1
#define PLAYER2	2

char borderSymbol;
char emptySymbol;
char mark1Symbol;
char mark2Symbol; 


int board[ROW][COLUMN]; 

int gameOver = FALSE;
int tryAgain = FALSE;
int winner = NONE;

void setupBoard(void);
void displayBoard(void);
int dropSpot(int column, int mark);
int acceptMove(int turn);
void evaluateMove(int *gameOver, int *winner);
void check4GameOver(int *);

/* *********************************** */
int main(int argc, char **argv)
/* *********************************** */
{
int i;
int selected_column=0;
int turn = 1;

setupBoard();
printf("Player1:%c\n", mark1Symbol);
printf("Player1:%c\n", mark2Symbol);
printf("\n\n");
while(!gameOver){
	displayBoard();
	selected_column = acceptMove(turn);
	if(dropSpot(selected_column,turn%2)!=-1){
		turn++;
		evaluateMove(&gameOver,&winner);
		}
	else {
		check4GameOver(&gameOver);
		}
	}

displayBoard();
printf("\n");
if(winner!= NONE)
	printf("The winner is Player%d\n",winner);
printf("Game Over\n");
}

/* *********************************** */
void setupBoard(void)
/* *********************************** */
{
int row,column;

borderSymbol = SHADOW1;
emptySymbol = SPACE;
mark1Symbol = SHADOW2;
mark2Symbol = LIGHT;

for(row=0;row<ROW;row++)
	for(column=0;column<COLUMN;column++)
		board[row][column] = emptySymbol;
}
 
/* *********************************** */
void displayBoard(void)
/* *********************************** */
{
int i,j;

for(i=0;i<2*ROW;i++){
	if(i%2){
		printf("%c%c%c%c%c%c%c%c%c",borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol);
		printf("%c%c%c%c%c%c\n",borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol,borderSymbol);
		}
	else{
		for(j=0;j<2*COLUMN+1;j++)
			if(!(j%2))
				printf("%c",borderSymbol);
			else
				printf("%c",board[ROW-1-i/2][j/2]);
		printf("\n");
		}
	}
printf("\n\n");
}

/* *********************************** */
int dropSpot(int column, int mark)
/* *********************************** */
{
int row;

if(board[5][column]!=emptySymbol){
	tryAgain = TRUE;
	return(-1);
	}
else {
	row=0;
	while(board[row++][column]!=emptySymbol);
	board[--row][column] = (mark==1?mark1Symbol: 
		mark2Symbol);	
	return(0);
	}
}

 
/* *********************************** */
int acceptMove(int turn)
/* *********************************** */
{
int column;

printf("Palyer%d:%c%s\n",(turn%2)?1:2,
			 (turn%2)?mark1Symbol:mark2Symbol,
			 tryAgain?" Try again,not posible to drop 
			there":" ");
printf("Enter column num (1-7):");
scanf("%d",&column);
return --column;

}

/* *********************************** */
void evaluateMove(int *gameOver, int *winner)
/* *********************************** */
{
// just for test
//*winner = PLAYER1;
//*gameOver = TRUE;
}

/* *********************************** */
void check4GameOver(int *gameOver)
/* *********************************** */
{
int column=0;
while((board[5][column++]!=emptySymbol)&&(column<=COLUMN+1));
if(column>=COLUMN)
	*gameOver = TRUE;
}
