/* Score 4.
        .
*/

#include "score4v2.h"


#define EMPTY 0
#define RED  1
#define YELLOW 2

#define PLAYER_COMPUTER 0
#define COMPUTER_PLAYER 1
#define PLAYER_PLAYER 2
#define COMPUTER_COMPUTER 3
#define QUIT 4

integer      weight[7][6]	 = {
		{3, 1, 0, 11, 20, 26},
		{0, 38, 33, 42, 39, 27},
		{35, 60, 74, 81, 77, 48},
		{72, 91, 91, 100, 88, 68},
		{37, 48, 88, 95, 81, 78},
		{9, 51, 25, 64, 22, 18},
		{3, 7, 6, 28, 26, 27}
	};



integer      board[8][7];
boolean      do_draw_board;

typedef struct {
	  integer      col, row;
	  integer      score;
	} TMove;


 
/* *********************************** */
void screen(int x, int y, int value, unsigned char color)
/* *********************************** */
{
  if (value == 0)
	  pokeb(0xb800,(x*2)+(y*160),color);
  else
	  pokeb(0xb800,(x*2)+(y*160)+1,color);

}


/* *********************************** */
void         clear_screen(void)
/* *********************************** */
{ 
  integer      x, y;
  clrscr();
  for (y = 0; y <= 23; y++)
	for (x = 0; x <= 79; x++)
	{
		 screen(x,y,0,char(' '));
		 screen(x,y,1,7);
	}
}


/* *********************************** */
void         init_board(void)
/* *********************************** */
{ 
	integer      x, y;

	clear_screen();
	for (y = 1; y <= 6; y++)
		 for (x = 1; x <= 7; x++)
		board[x][y] = EMPTY;
}


/* *********************************** */
void         draw_board(void)
/* *********************************** */
{ 
	integer      x, y;
	 integer      colour;

	for (x = 22; x <= 51; x++)
       for (y = 4; y <= 16; y++) 
       { 
		screen(x,y,0,219);
		if ((y % 2 == 0) || (x % 4 > 1))
			 screen(x,y,1,7);
		else
			 screen(x,y,1,0);
		 }

	for (y = 1; y <= 6; y++)
	{
		 for (x = 1; x <= 7; x++)
		 {
			  switch (board[x][y]) {

					case EMPTY:   colour = 0;
					break;

					case RED:   colour = 4;
					break;

					case YELLOW:   colour = 14;
					break;
			  }
			screen(20 + x * 4,3 + y * 2,1,colour);
			screen(21 + x * 4,3 + y * 2,1,colour);

		 }
		 printf("\n");
	}
}



/* *********************************** */
integer drop_piece(integer column,	integer colour)
/* *********************************** */
{ 
  integer      y;
  integer      drop_piece_result;

	 for (y = 6; y >= 1; y--)
	 {
		if (board[column][y] == EMPTY)
		{
		 board[column][y] = colour;
		 drop_piece_result=colour;
		 return drop_piece_result;
		}
	 }

	 if (do_draw_board)
	 {
		clear_screen();
		printf("\n");
		draw_board();
		delay(500);
	 }

	 return drop_piece_result;
}


/* *********************************** */
void         undrop_piece(integer      column)
/* *********************************** */
{ 
	integer      y;

	y = 1;
	while (board[column][y] == EMPTY)
		 y = y + 1;
	board[column][y] = EMPTY;

	if (do_draw_board)
	{
		 clear_screen();
		 printf("\n");
		 draw_board();
		 delay(500);
	}
}


/* *********************************** */
integer      min(integer      a,integer      b)
/* *********************************** */
{
	 integer min_result;
	 if (a < b)
		  min_result = a;
	 else
		  min_result = b;
	 return min_result;
}


/* *********************************** */
integer      max(integer      a, integer      b)
/* *********************************** */
{
	 integer max_result;
	 if (a > b)
		  max_result = a;
	 else
		  max_result = b;
	 return max_result;

}


/* *********************************** */
boolean is_connect_four_vert(integer x,integer y,integer team)
/* *********************************** */
{ 
	integer      i;
	boolean      flag;

	 if (y > 3)
		flag= false;
	 else
	 {
		flag= true;
		for (i = y; i <= (y + 3); i++)
			 if (board[x][i] != team)
				 flag= false;
	 }

	 return flag;
}


/* *********************************** */
boolean  is_connect_four_horiz(integer x,integer y,integer team)
/* *********************************** */
{ 
	nteger      i, run;
	boolean      flag;

	 run = 0;
	 flag= false;
	 for (i = max(x - 4,1); i <= min(x + 4,7); i++)
	 {
		if (board[i][y] == team)
		{
			 run = run + 1;
			 if (run == 4)
				flag= true;
		}
		else
			run = 0;
	 }

	 return flag;
}


/* *********************************** */
boolean  is_connect_four_ldiag(integer x,integer  y,integer team)
/* *********************************** */
{ 
  integer      pos, start, finish, run;
  boolean      flag;

	 start = -min(min(x - 1,y - 1),3);
	 finish = min(min(7 - x,6 - y),3);
	 run = 0;
	 flag= false;
	 for (pos = start; pos <= finish; pos++)
	 {
		if (board[x+pos][y + pos] == team)
		{
			 run = run + 1;
			 if (run == 4)
				flag= true;
		}
		else
			run = 0;
	 }

	 return flag;
}


/* *********************************** */
boolean is_connect_four_rdiag(integer x, integer  y, integer  team)
/* *********************************** */
{ 
  integer      pos, start, finish, run;
  boolean      flag;

	 start = -min(min(x - 1,6 - y),3);
	 finish = min(min(7 - x,y - 1),3);
	 run = 0;
	 flag= false;
	 for (pos = start; pos <= finish; pos++)
	 {
		if (board[x+pos][y - pos] == team)
		{
			 run = run + 1;
			 if (run == 4)
				flag= true;
		}
		else
			run = 0;
	 }

	 return flag;
}


/* *********************************** */
boolean      is_connect_four_diag(integer x,integer y, integer team)
/* *********************************** */
{
	 return (is_connect_four_ldiag(x,y,team) || is_connect_four_rdiag(x,y,team));
}

  /*  Checks for connect 4, going through (x, y)  */


/* *********************************** */
boolean      is_connect_four(integer  x)
/* *********************************** */
{ 
	integer      team;
	 integer      y;

	 y = 1;
	 while (board[x][y] == EMPTY)
		  y = y + 1;
	 team = board[x][y];
	 return (is_connect_four_diag(x,y,team) || is_connect_four_vert(x,y,team) || is_connect_four_horiz(x,y,team));
}


 
/* *********************************** */
void draw_piece(integer     col,integer      team)
/* *********************************** */
{ 
	integer      i;
	 integer      colour;

	 if (team == YELLOW)
		  colour = 14;
	 else
		  colour = 4;

	 screen(20 + col * 4,2,0,219);
	 screen(20 + col * 4 + 1,2,0,219);
	 screen(20 + col * 4,2,1,colour);
	 screen(20 + col * 4 + 1,2,1,colour);
}


/* *********************************** */
integer      read_spot(integer      team)
/* *********************************** */
{ 
  integer      col;
  char         key;

	 col = 4;
	 do {
		  clear_screen();
		  draw_piece(col,team);
		  draw_board();
		  key = getch();
		  if (key == '\x00')
		  {
			 switch (getch()) {

				 case 'K':   if (col > 1) col =col-1;
				 break;

				 case 'M':   if (col < 7)col=col + 1;
				 break;
				}
		  }
		  if (key == 'q')
				exit(0);
	 }while(!((key ==' ') && (board[col][1] == EMPTY)));
	 return col;
}


 
/* *********************************** */
integer      other_team(integer      team)
/* *********************************** */
{
	 if (team == RED)
		  return YELLOW;
	 else
		  return RED;
}

TMove        move_result;

/* *********************************** */
void  think(integer      team,integer      lookahead)
/* *********************************** */
{ 
	 integer      x;
	 TMove        best_move, this_move;
	 integer      a;

	 best_move.col = 4;
	 best_move.score = -16384;

	 for (this_move.col = 1; this_move.col <= 7; this_move.col++)
	 {
		if (board[this_move.col][1] == EMPTY)
		{
		 a = this_move.col;
		 this_move.row = drop_piece(this_move.col,team);

		 if (is_connect_four(this_move.col))
		 {
			 undrop_piece(this_move.col);
			 this_move.score = 16384;
			 move_result = this_move;
			 return;
		 }

		 this_move.score = 0;
		 if (lookahead > 0)
		 {
			think(other_team(team),lookahead - 1);
			this_move.score = -move_result.score * 5 / 6;
		 }
		 this_move.score = this_move.score + weight[this_move.col][this_move.row];
		 undrop_piece(this_move.col);

		 if (this_move.score > best_move.score)
		 {
			best_move.col = this_move.col;
			best_move.score = this_move.score;
		 }
		}
	 }

	 move_result = best_move;
}


/* *********************************** */
void draw_colour(integer first_row, integer last_row,	integer l, integer r, integer colour)
/* *********************************** */
{ 
	integer      i, j;

	 for (i = first_row; i <= last_row; i++)
	for (j = l; j <= r; j++)
		 screen(j,i,1,colour);

}


/* *********************************** */
void      menu(void)
/* *********************************** */
{ 
	integer      selected;
	 char         ch;

	 clear_screen();
	 printf("\n");
	 printf("              Score 4 -   . ............................\n");
	 printf("\n");
	 printf("              ........................., Maios 2001 \n");
	 printf("\n");
	 printf("\n");
	 printf(" Press \"q\" to quit, left & right arrows to move around and space bar to choo\n");

	 printf("\n");
	 printf("                           press <enter> to continue\n");


	 ch=getch();
}


/* *********************************** */
integer      do_computer_move(integer      team)
/* *********************************** */
{
	 clear_screen();
	 draw_piece(4,team);
	 draw_board();

	 think(team,5);
	 return move_result.col;
}


/* *********************************** */
void    main_loop(void)
/* *********************************** */
{
	 integer      team;
	 integer      spot, dum;
	 integer      move_num;
	 char         dummy;
	 boolean      computer_yellow;
	 boolean      computer_red;


	 menu();
	 computer_yellow = false;
	 computer_red = true;

	 init_board();
	 do_draw_board = false;

	 team = RED;
	 move_num = 0;
	 do {
		move_num = move_num + 1;
		team = other_team(team);

		if (team == YELLOW)
		{
			 if (computer_yellow)
				 spot = do_computer_move(team);
			 else
				 spot = read_spot(team);
		}
		else
		{
			 if (computer_red)
				 spot = do_computer_move(team);
			 else
				 spot = read_spot(team);
		}

		dum = drop_piece(spot,team);

	 }  while (!(is_connect_four(spot) || (move_num == 42)));

	 clear_screen();
	 printf("\n");
	 draw_board();
	 printf("\n");

	 if (team == RED)
			printf("  RED player won\n");
	 else
			printf("  YELLOW player won\n");
	 dummy = getch();
}


/* *********************************** */
main(int   argc,char  *argv[])
/* *********************************** */
{
	 while (true) main_loop();
}
