/********************************************************************/
/********************************************************************/
	      /*     The towers of Anoi       */
/********************************************************************/
	      /*     Karatzas Emmanouil       */
	      /*        A.M. :3632            */
/********************************************************************/
/********************************************************************/
/********************************************************************/
/*  INTERACT.C  :  interactive() , get_coord()                      */
/********************************************************************/

#include "anoi.h"
#include "error.h"

/***********************************************************************/
/***********************************************************************/

extern void print_all(int pin[][MAX_TOWER_HIGHT],int circle_num);
extern int move(int pin1[],int pin2[],int circle_num);
extern void array_set(int pin[][MAX_TOWER_HIGHT],int circle_num);

static struct coordinates get_coord();

/***********************************************************************/
struct results interactive(int circle_num) /* Main function for the game */
/***********************************************************************/
{

int pin[TOWERS_NUM][MAX_TOWER_HIGHT];
int counter_correct=0;
int counter_error=0;
struct coordinates new_coord;  
struct results result;

array_set(pin,circle_num);
print_all(pin,circle_num);   /* Print the towers for the first time */

while(pin[1][circle_num-1]==0){ /* Check for the succesful end of the game */
   new_coord=get_coord();
   if(new_coord.status==VALID)
      if(move(pin[new_coord.from-1],pin[new_coord.to-1],circle_num)==VALID)
	 counter_correct++;
      else{
	 print_error();
	 counter_error++;
	 }
   else if(new_coord.status==TERMINATE){  /* Check the ending condition */
      result.counter_correct=counter_correct;
      result.counter_error=counter_error;
      result.status=TERMINATE;
      return result;
      }
   else{
      print_error();
      counter_error++;
      }  
   print_all(pin,circle_num);  /* Print the new arangement of the towers */
   }
result.counter_correct=counter_correct;
result.counter_error=counter_error;
result.status=SUCCESS;
return result;
}



/********************************************************************/
struct coordinates get_coord()
/********************************************************************/
{

struct coordinates new_coord;
int from,to;

printf("Please type the next movement (or From :0 , To :0 to exit)\n");
printf("From :");   /* Input of the tower to be moved */
scanf("%d",&from);
printf("To :");     /* Input of the destination */
scanf("%d",&to);
if(from!=to && from<4 && from>0 && to<4 && to >0){  /* Check if the */
						  /* inputs are correct */
   new_coord.from=from;
   new_coord.to=to;
   new_coord.status=VALID;
   }
else if(from==0 && to==0)     /* Check the ending condition */
   new_coord.status=TERMINATE;
else{
   flag=COORDINATES; 
   new_coord.status=NOT_VALID;
   }
return new_coord;
}  

