/********************************************************************/
/********************************************************************/
	      /*     The towers of Anoi       */
/********************************************************************/
	      /*     Karatzas Emmanouil       */
	      /*        A.M. :3632            */
/********************************************************************/
/********************************************************************/
/********************************************************************/
/* MAIN.C : main(), get_selection(), get_tower_hight(), print_result() */
/********************************************************************/

#include <stdio.h>
#include "anoi.h"
#include "error.h"

extern void demo(int circle_num);
extern struct results interactive(int circle_num);

static int get_selection();
static int get_tower_hight();
static void print_result(int circle_num,struct results result);

main()   
{        

int choice,circle_num;
struct results result;

printf(" *************************************************\n");
printf(" ********* Wellcome to the towers of Anoi ********\n");
printf(" *************************************************\n\n\n");

printf(" ****  This programm has been developed as a    ****\n");
printf(" ****  project for the cource of learning the   ****\n");
printf(" ****         programming language C,           ****\n");
printf(" ****          by Emmanouil Karatzas            ****\n\n\n");

while((choice=get_selection())!=END){
   
   if(choice==-1)
      exit(-1);
   
   if((circle_num=get_tower_hight())==-1)
      exit(-1);

   switch(choice){
      case DEMO:                  /* Pass the control to the main  */ 
   	   demo(circle_num);        /* part of the programm */ 
	   result.status=DEMO;
	   break;
      case INTERACTIVE :
   	   result=interactive(circle_num);
	   break;
      default :     
	   exit(-1);
           break;   
	   }

   print_result(circle_num,result);
   }
exit(0);
}



/***********************************************************************/
int get_selection()         /* Choice for the programm opperation */
/***********************************************************************/
{

int choice;
int input_num=0;

printf("     Press : \n");
printf("   1. if you want to play the game  \n");
printf("   2. if you want to view the solution of the game \n");
printf("   3. if you want to exit  \n\n");
printf("   Please type a number :");  
scanf("%d",&choice);                     
while(choice!=INTERACTIVE && choice!=DEMO && choice!=END && input_num++<3){ 
   flag=SELECTION;                             /* Check for the */       
   print_error();                              /* correct input */
   scanf("%d",&choice);                         
   }

if(input_num>3)          /* Check to limit the wrong inputs */
   return -1;
else 
   return choice;
}



/*********************************************************************/
int get_tower_hight()    /* Input of the number of the */ 
			 /* circles that will be used */
/*********************************************************************/
{

int circle_num;
int input_num=0;
printf("\n\nPlease type the number of circles :");
scanf("%d",&circle_num);
while(!(circle_num<=13 && circle_num>=1) && input_num++<3){  
   flag=HIGHT;                              /* Check if the number of the */ 
   print_error();                           /* variables is such a number */
   scanf("%d",&circle_num);              /* that their print will be able */
   }                                         /* to be seen at the monitor */
					    

if(input_num<=3)          /* Check to limit the wrong inputs */
   return circle_num;
else
   return -1;
}




/*********************************************************************/
void print_result(int circle_num,struct results result)
/*********************************************************************/
{

int i;
int moves=0;

for(i=1;i<=circle_num;i++)    /* Define the total number of moves */
   moves=moves*2+1;

if(result.status==DEMO){
   printf("End of demo \n");     
   printf("Number of moves : %d\n\n\n",moves);
   return;
   }
else if(result.status==TERMINATE)           
   printf("\nTerminating game... Try another time!\n");  
else if(result.status==SUCCESS){
   printf("\n***************************\n");   
   printf("  Success !!! End of game.\n");       
   printf("***************************\n");
   }
printf("You did %d correct moves ",result.counter_correct);
printf("and %d wrong moves,\n",result.counter_error);
printf("while you could have ended the game in %d moves.\n\n\n",moves);
return;
}

