/********************************************************************/
/********************************************************************/
	      /*     The towers of Anoi       */
/********************************************************************/
	      /*     Karatzas Emmanouil       */
	      /*        A.M. :3632            */
/********************************************************************/
/********************************************************************/
/********************************************************************/
/*    MOVE.C  :  move() , check_move() , find_top()                 */
/********************************************************************/

#include "anoi.h"
#include "error.h"

/***********************************************************************/
/***********************************************************************/

static int check_move(int source,int target);
static int find_top(int pin[],int circle_num);

/*************************************************************************/
int move(int pin1[],int pin2[],int circle_num) /* Function that moves the */
						 /* upper array element */ 
/*************************************************************************/
{                                            

int source_index,target_index; 

if((source_index=find_top(pin1,circle_num))==-1){ 
				  /* Check if ther is anything to move */
   flag=STUCK;
   return NOT_VALID;
   }

if((target_index=find_top(pin2,circle_num))==circle_num-1){
   flag=OVERFLOW; 
   return NOT_VALID;
   }

if(check_move(pin1[source_index],pin2[target_index])==VALID 
					|| target_index==-1){     
   pin2[++target_index]=pin1[source_index];   /* Move the upper element */
   pin1[source_index]=0;
   return VALID;
   }
else{
   flag=RULE;
   return NOT_VALID;
   }
}



/***********************************************************************/
int check_move(int source,int target)   /* Function that checks if the */
				/* movement is correct, according to the */
					    /* rules of the game */
/***********************************************************************/
{

if(target==0 || target>source)
   return VALID;
else
   return NOT_VALID;
}


/************************************************************************/
int find_top(int pin[],int circle_num)
/************************************************************************/
{
int i=0;
while(pin[i]!=0)            /* The upper array element is found by the */
   if(i++<(circle_num-1))   /* fact that after it ther is 0 or nothing */
      continue;
   else
      break;
return --i;
}

