/*  "THE HANOI TOWERS" GAME !!!

	Released on 27.5.1996, by:

		Afxendios A. Tychopoulos
		Student e/e department
		Polytechnic School
		Univercity of Patras
		Y.o.S. C' - s.n. 3548.

--------------------------------------------------------------------------
*/

#include <toh.h>

int *column;
int *gameb[3];
int flag,maxcyls,n,oldcol,finaltargetc,targetc,fstep,
	tdelay=700; /* in milliseconds */
long timeconst,
	 mov=0;

#include <toh.f>

main(int argc, char **argv) {

	flag=chkcoml(argc,argv,comlineparamset); /* CHECK COMMAND LINE ARGUMENTS */

	if(flag & pow2(HELP)) {
		print_file("README.TOH");
		exit(0);
	}

	sys_config(); /* CHECK SYSTEM FOR HARDWARE DEMANDS */

	if(!(flag & pow2(INTRO)))
		introduction(); 		/* INTRODUCTION */

	get_parameters();           /* INPUT OF n, initial & final column */
	gameboard_init();           /* INITIALIZATION OF GAME MATRIXES */
	first_step();				/* PROPER FIRST INCREASE OF COLUMN, TO DRIVE CYLS TO PREDEFINED DESTINATION */
	screen_init();			    /* TO DISPLAY IN COLOR TEXT MODE */
	timeconst=clock();			/* CLOCK INITIALIZATION */

	if(!(flag & pow2(DEMO))) {
		showmouse();
		do {
			get_col(&oldcol,&targetc);
			gameplay();
		}
		while(!checkgame());
	}
	else
		if(flag & pow2(FEEDBACK))       /* PLAY DEMO WITH FEEDBACK */
			movtrees(n);
		else
			movtree();					/* PLAY DEMO WITHOUT FEEDBACK */

	termination(-1);			        /* BYE-BYE */

return 1;
}



/* FUNCTION MOVTREES WITH FEEDBACK - ENHANCED VERSION OF TOH GAME */

/* ********************************************************************* */
void movtrees(int num) {
/* ********************************************************************* */

register elem,tmp1,tmp2;
int increase;

for(elem=1;elem<=num;elem++) {
	increase=find_increase(elem); /* INCREASE OF CURRENT COLUMN (+1 OR +2) */
	tmp1=fzelem(gameb[*(column+elem-1)-1],maxcyls+1);
	targetc=newcol(*(column+elem-1),increase); /* TARGET COLUMN DEF */
	tmp2=fzelem(gameb[targetc-1],maxcyls+1);
	*(gameb[targetc-1]+tmp2)=elem;     /* COPY CYL 'elem' TO TARGET COL */
	*(gameb[*(column+elem-1)-1]+tmp1-1)=0; /* DEL CYL FROM FORMER COL */
	mov++; 							   /* INCREASE MOVE COUNTER */
	showmove(elem,(22-n)/2+n+3-tmp1,(22-n)/2+n+2-tmp2); /* DISPLAY RESULT */
	*(column+elem-1)=targetc; 		   /* NOTE NEW COLUMN */

	/* EXECUTION SPEED REGULATION */
	tdelay=speed_regulator((clock()-timeconst)/18.2,MOVESPERSEC_D,TIMECOEFF);
    if(elem==1) continue;
	movtrees(elem-1); /* FEEDBACK */
}
return;
}



/* FUNCTION MOVTREE - FIRST VERSION OF THE TOH GAME - WITHOUT FEEDBACK */

/* ********************************************************************* */
void movtree() {
/* ********************************************************************* */

register elem,tmp1,tmp2;
int increase;
double k;

for(mov=1.0;mov<=power(2,n)-1;mov++)   /* MOVE COUNT */
	for(elem=1;elem<=n;elem++) {       /* CYLINDER COUNT */
		k=mov/power(2,elem)-0.5;       /* K=INT => MOVE CYL 'elem' */
		if(k-((long) k)) continue;
		increase=find_increase(elem);  /* COLUMN INCREASE DEF (+1 OR +2) */
		targetc=newcol(*(column+elem-1),increase); /* TARGET COLUMN DEF */
		tmp1=fzelem(gameb[*(column+elem-1)-1],maxcyls+1);
		tmp2=fzelem(gameb[targetc-1],maxcyls+1);
		*(gameb[targetc-1]+tmp2)=elem; /* COPY CYL TO DESTIN */
		*(gameb[*(column+elem-1)-1]+tmp1-1)=0; /* ERASE FROM ORIGIN */
		showmove(elem,(22-n)/2+n+3-tmp1,(22-n)/2+n+2-tmp2); /* DISPLAY RESULT */
		*(column+elem-1)=targetc;      /* NOTE NEW COLUMN */

		/* EXECUTION SPEED REGULATION */
		tdelay=speed_regulator((clock()-timeconst)/18.2,MOVESPERSEC_D,TIMECOEFF);
		break;
	}
return;
}


/* NOW YOU PLAY */
/* ********************************************************************* */
void gameplay() {
/* ********************************************************************* */

register elem,tmp1,tmp2;

tmp1=fzelem(gameb[oldcol-1],maxcyls+1);
elem=*(gameb[oldcol-1]+tmp1-1);    /* WHICH IS THE CHOSEN CYLINDER */
tmp2=fzelem(gameb[targetc-1],maxcyls+1);
*(gameb[targetc-1]+tmp2)=elem;     /* COPY CYL TO DESTIN */
*(gameb[oldcol-1]+tmp1-1)=0;	   /* ERASE FROM ORIGIN */
mov++;                             /* INCREASE MOVE COUNTER */
showmove(elem,(22-n)/2+n+3-tmp1,(22-n)/2+n+2-tmp2); /* DISPLAY RESULT */

*(column+elem-1)=targetc;          /* NOTE NEW COLUMN FOR CYL "ELEM" */
tdelay=speed_regulator((clock()-timeconst)/18.2,MOVESPERSEC_P,TIMECOEFF);

return;
}
