/* INCLUDES THE FUNCTIONS FOR THE GAME "THE HANOI TOWERS":
--------------------------------------------------------------------------
*/


/* *********************************************************************** */
void sys_config() {
/* *********************************************************************** */

        int s=sizeof(int);

        setcbrk(0);     /* PARTLY DISABLE CONTROL-BREAK */

                                        /* CHECK FOR MOUSE DRIVER, IF TOH GAME PLAYED BY USER */

        if( !(flag & pow2(DEMO)) && !mouseinit() ) {
                printf("\nMouse driver not found!");
                exit(0);
        }

    cursor(6,7);        /* HIDE CURSOR */
        textmode(C80);  /* CHECK TEXTMODE */

        /* MEMORY ALLOCATION FOR THE TOH GAME INT MATRIXES "GAMEB" & "COLUMN" */

        if( (flag & pow2(MATRIX)) && (flag & pow2(DEMO)) )
                maxcyls=MAXCYLS_MATRIX;
        else
                maxcyls=MAXCYLS_TEXT;
        column=malloc(s*(maxcyls+1));
        gameb[0]=malloc(s*(maxcyls+1));
        gameb[1]=malloc(s*(maxcyls+1));
        gameb[2]=malloc(s*(maxcyls+1));
        if(!column || !gameb[0] || !gameb[1] || !gameb[2]) {
                printf("Out of memory!\n");
                exit(0);
        }

return;
}


/* *********************************************************************** */
int speed_regulator(float secs,float limit,float coeff) { /* time in seconds */
/* *********************************************************************** */

return (mov/secs > limit) ? (int) tdelay*coeff : (int) tdelay/coeff;
}


/* *********************************************************************** */
void showmouse() {
/* *********************************************************************** */

mousecursor(MOUSECURSOR);
mouseshow();
}


/* Introduction graphics */

/* *********************************************************************** */
int introduction(void) {
/* *********************************************************************** */

register i;
char
label01[44]="Ŀ",
label02[44]="                                          ",
label03[44]="                                       ",
label04[44]="                                       ",
label05[44]="       T H E                            ",
label06[44]="                                       ",
label07[44]="     H A N O I                          ",
label08[44]="                                       ",
label09[44]="    T O W E R S                         ",
label10[44]="    ",
label11[44]="                                          ",
label12[44]="",
label13[44]="Copyright 1996 - By Afxendios Tychopoulos.  ",
labelAA[64]="͸",
label14[64]="          ***    THE RULES OF THE HANOI TOWERS     ***        ",
labelBB[64]="Ĵ",
label15[64]=" 1) The cylinders must move to another column, one at a time. ",
label16[64]=" 2) Small cylinders must always be over the bigger ones.      ",
labelCC[64]="";

SCREENC(INTROD_MBACK_COLOR,INTROD_M1CHAR_COLOR)
clrscr();
SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C,1,1,i,80,label)

SCREENC(INTROD_MBACK_COLOR,INTROD_M2CHAR_COLOR)
PUTCHSTR(17,3,i,44,label01)
PUTCHSTR(17,4,i,44,label02)
PUTCHSTR(17,5,i,44,label03)
PUTCHSTR(17,6,i,44,label04)
PUTCHSTR(17,7,i,44,label05)
PUTCHSTR(17,8,i,44,label06)
PUTCHSTR(17,9,i,44,label07)
PUTCHSTR(17,10,i,44,label08)
PUTCHSTR(17,11,i,44,label09)
PUTCHSTR(17,12,i,44,label10)
PUTCHSTR(17,13,i,44,label11)
PUTCHSTR(17,14,i,44,label12)
SCREENC(INTROD_MBACK_COLOR,INTROD_M3CHAR_COLOR)
PUTCHSTR(17,15,i,44,label13)
PUTCHSTR(8,18,i,64,labelAA)
PUTCHSTR(8,19,i,64,label14)
PUTCHSTR(8,20,i,64,labelBB)
PUTCHSTR(8,21,i,64,label15)
PUTCHSTR(8,22,i,64,label16)
PUTCHSTR(8,23,i,64,labelCC)

SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C+BLINK,27,25,i,25,label0)
WAITFORKEY

return 1;
}


/* INPUT of n, ORIGINAL & column of DESTINATION */

/* *********************************************************************** */
void get_parameters(void) {
/* *********************************************************************** */

register i;


checkbuf(0);
SCREENC(GET_PARAM_BACK_C,GET_PARAM_CHAR_C)
clrscr();
SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C,1,1,i,80,label)
SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C+BLINK,17,22,i,46,label00)

SCREENC(GET_PARAM_BACK_C,GET_PARAM_CHAR_C)
gotoxy(QX,Q1Y);           							/* INPUT n */
printf("Give number of cylinders (1-%d): ",maxcyls);
while((n=cgetint(5))<0 || n>maxcyls) {
        gotoxy(QX+33,Q1Y);
        clreol();
}
if(!n) n=maxcyls;

gotoxy(QX,Q2Y);										/* INPUT INITIAL COLUMN */
printf("Which is the original column of the cylinders ? (1,2,3): ");
while((*column=cgetint(4))<0 || *column>3) {
        gotoxy(QX+57,Q2Y);
        clreol();
}
if(!(*column)) *column=n%3+1;

gotoxy(QX,Q3Y); 									/* INPUT FINAL COLUMN */
printf("Which is the column of destination ? (1,2,3): ");
while((finaltargetc=cgetint(4))<0 || finaltargetc>3 || finaltargetc==*column) {
        gotoxy(QX+46,Q3Y);
        clreol();
}
if(!finaltargetc) finaltargetc=newcol(*column,n%2+1);

return;
}


/* Initialization of game board */

/* *********************************************************************** */
gameboard_init() {
/* *********************************************************************** */

register tmp,elem;

for(tmp=1;tmp<=3;tmp++)
        for(elem=1;elem<=n+1;elem++) {
                if(tmp==*column) {
                        if(elem<=n) {
                                *(gameb[tmp-1]+elem-1)=n-elem+1;
                                *(column+elem-1)=tmp;
                        }
                                                else *(gameb[tmp-1]+elem-1)=0;
                }
                                else *(gameb[tmp-1]+elem-1)=0;
        }
return;
}

/* Calculation of the correct first increase of column (first step),
   in order to gather cylinders in the desired column of destination */

/* *********************************************************************** */
void first_step() {
/* *********************************************************************** */

        switch(finaltargetc-*column) {
				case -2:
				case +1:
					fstep=1+even(n);
					break;
				default:
					fstep=2-even(n);
					break;
		}
return;
}


/* INCREASE OF COLUMN (+1 OR +2) */

/* *********************************************************************** */
int find_increase(int elem) {
/* *********************************************************************** */

return (fstep-1) ? ((!even(elem)) ? +2 : +1) : ((!even(elem)) ? +1 : +2);
}


/* INPUT OF "FROM COLUMN" AND "TO COLUMN" FOR GAMEPLAY */

/* *********************************************************************** */
void get_col(int *oldcol,int *newcol) {
/* *********************************************************************** */

int x,y,button;
do {

	do {
		while(!mousebutton(0))
			termination(checkbuf(TERM_CHAR) || mousebutton(1) );
        mousecoord(&x,&y,&button);
		CLICKSOUND(SOUND_FREQ_1)
		if(x>=1 && x<=27) *oldcol=1;
        if(x>=28 && x<=54) *oldcol=2;
        if(x>=55 && x<=80) *oldcol=3;
}
while(!(*gameb[*oldcol-1]));

		while(!mousebutton(0))
        	termination(checkbuf(TERM_CHAR) || mousebutton(1) );
		mousecoord(&x,&y,&button);
		CLICKSOUND(SOUND_FREQ_2)
        if(x>=1 && x<=27) *newcol=1;
        if(x>=28 && x<=54) *newcol=2;
        if(x>=55 && x<=80) *newcol=3;
}
while( *oldcol == *newcol );

return;
}


/* CHECK IF PLAYER HAS ACCOMPLISHED THE GAME */

/* *********************************************************************** */
int checkgame() {
/* *********************************************************************** */

register j,elem;

/* CHECK IF MOVE COMPLIES WITH THE RULES AND PERFORMS CORRECTION */

for(elem=0 ; *(gameb[targetc-1]+elem) ; elem++)
        if(*(gameb[targetc-1]+elem) <= *(gameb[targetc-1]+elem+1)) {
                SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C+BLINK,GAMESCR_LAB000_X,GAMESCR_LAB000_Y,j,13,label000)
                delay(3*tdelay);
                for(j=0;j<13;j++) {
                        SCREENC(GAMESCR_BACK_C,GAMESCR_CHAR_C)
                        gotoxy(GAMESCR_LAB000_X+j,GAMESCR_LAB000_Y);
                        putch(' ');
                }
                j=targetc;
                targetc=oldcol;
                oldcol=j;
                gameplay();
        }

/* CHECK IF GAME HAS BEEN ACCOMPLISHED */

for(elem=0;elem<n;elem++)       /* Have all cyls gathered on destination col ? */
        if(*(column+elem) != finaltargetc )
                return 0;

return 1;
}


/* Screen initialization */

/* *********************************************************************** */
void screen_init() {
/* *********************************************************************** */

register i,j;
char
nb1[57]="ͻ",
nb2[57]="  MIN. MOVES TOTAL:          TARGETING COLUMN:        ",
nb3[57]="  CURRENT MOVEMENT:          ELAPSED TIME:            ",
nb4[57]="ͼ";

if(!(flag & pow2(MATRIX)) || !(flag & pow2(DEMO)) ) {
                                SCREENC(GAMESCR_BACK_C,GAMESCR_CHAR_C)
                clrscr();

                                SCREENC(LABEL_BACK_C,LABEL_CHAR_C)
                PUTCHSTR(1,1,j,80,label)

        SCREENC(TABLO_BACK_COLOR,TABLO_CHAR_COLOR)
        for(j=1;j<=n+2;j++)
                for(i=1;i<=3;i++) {
                        gotoxy(27*i-13,(22-n)/2+j);
                        putch('');
                }
                gotoxy(1,(22-n)/2+n+3);
        for(i=1;i<=80;i++)
                putch('');

        SCREENC(NOT_BOARD_BACK_COLOR,NOT_BOARD_CHAR_COLOR)
                                PUTCHSTR(13,n/4+19,i,57,nb1)
                                PUTCHSTR(13,n/4+20,i,57,nb2)
                                PUTCHSTR(13,n/4+21,i,57,nb3)
                                PUTCHSTR(13,n/4+22,i,57,nb4)

        for(i=n;i>=1;i--) {
                sound((1200/n)*(n-i+1));
                                showcyl(i,27*(*column)-13,(22-n)/2+i+2,CYL_CHAR);
                delay(SOUNDDELAY);
        }
        nosound();

        SCREENC(NOT_BOARD_BACK_COLOR,NOT_BOARD_CHAR_COLOR)
                gotoxy(34,n/4+20);
				printf("%4d.",(1 << n)-1);
                gotoxy(62,n/4+20);
				printf("%4d.",finaltargetc);
                gotoxy(34,n/4+21);
				printf("%4ld.", mov);
                gotoxy(58,n/4+21);
				printf("%s.",timetable);
}

return;
}


/* Shows one cylinder on the screen */

/* *********************************************************************** */
int showcyl(int elem, int x, int y, char c) {
/* *********************************************************************** */

register i;

SCREENC(TABLO_BACK_COLOR,(elem<8) ? 16-elem : 15-elem)
gotoxy(x-elem,y);
for(i=1;i<=2*elem+1;i++)
        putch(c);

return 1;
}


/* Shows the move of one cylinder on the screen, when graphics */

/* *********************************************************************** */
int showmove(int elem,int oldy,int newy) {
/* *********************************************************************** */

register i,j;

if( !(flag & pow2(MATRIX)) || !(flag & pow2(DEMO)) ) {

showtime((clock()-timeconst)/CLK_TCK,timetable);
SCREENC(NOT_BOARD_BACK_COLOR,NOT_BOARD_CHAR_COLOR)
gotoxy(34,n/4+21);
printf("%4ld.", mov);
gotoxy(58,n/4+21);
printf("%s.",timetable);

/* Upwards */

delay(3*tdelay);
j=27*(*(column+elem-1))-13;
for(i=oldy;i > (22-n)/4+1;i--) {
        termination( checkbuf(TERM_CHAR) || mousebutton(1) );
        showcyl(elem,j,i,' ');
        if(i >= (22-n)/2+1) {
                SCREENC(TABLO_BACK_COLOR,TABLO_CHAR_COLOR)
                gotoxy(j,i);
                putch('');
        }
showcyl(elem,j,i-1,CYL_CHAR);
delay(tdelay/9);
}

/* Horizontally */

delay(2*tdelay/3);
j=(22-n)/4+1;
if(targetc > *(column+elem-1)) /* TO THE RIGHT */
        for(i=27*(*(column+elem-1))-13-elem;i<=27*targetc-14-elem;i++) {
                termination( checkbuf(TERM_CHAR) || mousebutton(1) );
                        gotoxy(i,j); putch(' ');
                        gotoxy(i+2*elem+1,j); putch(CYL_CHAR);
                        delay(tdelay/10);
        }
else /* TO THE LEFT */
        for(i=27*(*(column+elem-1))-13+elem;i>=27*targetc-12+elem;i--) {
                termination( checkbuf(TERM_CHAR) || mousebutton(1) );
                        gotoxy(i,j); putch(' ');
                        gotoxy(i-2*elem-1,j); putch(CYL_CHAR);
                        delay(tdelay/10);
        }

/* Downwards */

delay(2*tdelay/3);
j=27*targetc-13;
for(i=(22-n)/4+1;i < newy;i++) {
        termination( checkbuf(TERM_CHAR) || mousebutton(1) );
        showcyl(elem,27*targetc-13,i,' ');
        if(i >= (22-n)/2+1) {
                SCREENC(TABLO_BACK_COLOR,TABLO_CHAR_COLOR)
                gotoxy(j,i);
                putch('');
        }
showcyl(elem,27*targetc-13,i+1,CYL_CHAR);
delay(tdelay/9);
}

}

else {

termination(checkbuf(TERM_CHAR));
delay(tdelay);
gotoxy(1,25);
printf("\n\n\nMove number: %ld.\n", mov);
for(i=0;i<3;i++) {
        printf("\n");
        for(j=0;j<n;j++)
                printf("%2d ",*(gameb[i]+j));
}

}

return 1;
}


/* Programme termination by user:
        0 - termination abortion
        1 - abnormal termination
        2 - normal termination */

/* *********************************************************************** */
void termination(int cmd) {
/* *********************************************************************** */

register j;

if(cmd) {
        printf("\a");
        mousehide();            /* DISABLE MOUSE */
                                                /* WAIT FOR KEY STATUS */
        if(cmd == -1 && !(flag & pow2(MATRIX))) {
                SHOWLABEL(LABEL_BACK_C,LABEL_CHAR_C+BLINK,GAMESCR_LAB0_X,GAMESCR_LAB0_Y,j,25,label0)
                checkbuf(0);
                WAITFORKEY
        }
                                                /* PRINT MESSAGE */
        SCREENC(0,7)
        clrscr();
        gotoxy(16,11);
        if(cmd == -1)
                printf("All thanks to your deep concentration...");
        else
                printf("You lost your concentration...");
        gotoxy(16,13);
		printf("the Hanoi Tower has %sbeen properly raised !!!\n\n\n",(cmd!=-1)?"not ":"");

        checkbuf(0);        /* CLEAR BUFFER */
		setcbrk(1);         /* ENABLE FULL CONTROL-BREAK */
        cursor(7,6);        /* CURSOR ON */
        exit(0);            /* ABANDON PROGRAMME EXECUTION */
}
return;
}