/* ******************************************************** */
int mouseinit()
/* ******************************************************** */

{	/* IF MOUSE DRIVER FOUND, RETURNS NONZERO (-1) */
	union REGS ir, or;

	ir.x.ax = 0;
	int86(0x33, &ir, &or);
	return or.x.ax;
}


/* ******************************************************** */
void mousecursor(char c)
/* ******************************************************** */

{   /* CHANGES THE MOUSE'S POINTING CURSOR */
	union REGS ir, or;

	ir.x.ax = 10;
	ir.x.bx = 0;
	ir.x.cx = 0;
	ir.x.dx = 0x0700 + c;
	int86(0x33, &ir, &or);
	return;
}


/* ******************************************************** */
void mouseshow()
/* ******************************************************** */

{	/* SHOWS MOUSE POINTING CHARACTER */
	union REGS ir, or;

	ir.x.ax = 1;
	int86(0x33, &ir, &or);
	return;
}


/* ******************************************************** */
void mousehide()
/* ******************************************************** */

{   /* DISABLES MOUSE */
	union REGS ir, or;

	ir.x.ax = 2;
	int86(0x33, &ir, &or);
	return;
}


/* ******************************************************** */
int mousebutton(int which)  /* 0 = left,   1 = right,   2 = middle */
/* ******************************************************** */

{	/* RETURNS HOW MANY TIMES MOUSE BUTTON "WHICH" HAS BEEN PRESSED */
	union REGS ir, or;

	ir.x.ax = 5;
	ir.x.bx = which;
	int86(0x33, &ir, &or);
	return or.x.bx;
}

/* ******************************************************** */
void mousecoord(int *x, int *y, int *b)
/* ******************************************************** */

{   /* RETURNS THE COORDINATES OF THE MOUSE POINTER
	AND THE NUMBER OF PRESSED BUTTON (LEFT=1,RIGHT=2) */
	union REGS ir, or;

	ir.x.ax = 3;
	int86(0x33, &ir, &or);
	*x = (or.x.cx >> 3)+1;
	*y = (or.x.dx >> 3)+1;
	*b = or.x.bx;
	return;
}

