/* Hanoi   -- Solve the ancient problem of the Hanoi Towers. Demo solution */
/*            included.                                                    */
/*                                                                         */
/* Copyright (c) 1996 Leonidas Vomvoridis    a95-3597@amalia.ee.upatras.gr */
/*                                                                         */
/* This program is free software; you can redistribute it and/or modify it */
/* under the terms of the  GNU General Public License  as published by the */
/* Free Software Foundation.  This program is distributed in the hope that */
/* it will be useful, but  WITHOUT ANY WARRANTY; without even the  implied */
/* warranty of  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE. See */
/* the GNU General Public License for more details.                        */


/* HANOI.H     -- header file for hanoi.c */


/* These are for the "Exiting to..." message. Customize for a different OS */
#ifdef __linux__
#define OSTYPE "Linux"     /* The _uLtIMaTe_ system */
#endif
#ifdef __MSDOS__
#define OSTYPE "MS-DOS"    /* Good old dos */
#endif
#ifdef __hpux
#define OSTYPE "HP-UX"     /* &@#$#&@%! */
#endif
#ifndef OSTYPE
#define OSTYPE "Operating System"
#endif

#define MAXPIECES 11       /* default for 80x25 display mode  */

char move(char,char);      /* move from col a to col b        */

solve(char,char,char);     /* move n pieces from col a to b   */

init();                    /* initialize matrix               */

demo();                    /* demo solution                   */

interact();                /* playable game                   */

display();                 /* ascii display of current layout */

help();                    /* online help for playable game   */

display_menu();            /*                                 */

presskey();                /* 'press enter' function          */

